!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-

!latex \item Constructs field magnitude on interfaces.
!latex Also constructs covariant representation of magnetic field and write pressure-jump Hamiltonian input.

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

subroutine cb02aa
  
  use constants, only : zero, half, one, pi2, goldmean
  use numerical, only : machprec, small
  use fileunits, only : ounit, irrationunit
  use inputlist, only : Ni, mu, Mpol, Ntor, pl, pr, ql, qr, Nfp, ext, Nvol, Lsetmupf, pres, pscale, Iusesg, Wcb02aa
  use cputiming
  use allglobal, only : myid, cpus, ll, mn, ss, swI, Nt, Nz, Ntz, Iwrpj, &
                        mn, im, in, efmn, ofmn, cfmn, sfmn, isr, trigm, trign, trigwk, ijreal, ijimag, jireal, jiimag, sg, gij, &
                        Atmn, Azmn, Bdmn, Idmn, Rbc, Zbs
                              
  use pjhamilto, only : Itor, Gpol, spmn
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

  LOCALS
  
  INTEGER   :: ii, io, imn, ifail, lli, Lcurv
  REAL      :: lss
  CHARACTER :: suff*5 ! this suffix labels the .pj files that will be written;

  BEGIN(cb02aa)

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

  if( Wcb02aa ) then ; cput = MPI_WTIME() ; write(ounit,'("cb02aa : "f10.2" : ll="i3" ;")')cput-cpus,ll
  endif

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
  Bdmn(0,1:mn) = zero ; Bdmn(1,1:mn) = one ; Idmn(1:mn) = one ! initialize "intent out"; these are passed through globals;

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
  ADDCPU(cb02aa)

  if( Wcb02aa ) then ; cput = MPI_WTIME() ; write(ounit,'("cb02aa : "f10.2" : ll="i3" ; calling sw02aa ;")')cput-cpus,ll
  endif

  CALL(sw02aa) ! sw02aa calculates spectral constraints on ll-th interface; depends only on Rbc, Zbs; returns swI through global;

  if( Wcb02aa ) then ; cput = MPI_WTIME() ; write(ounit,'("cb02aa : "f10.2" : ll="i3" ; called  sw02aa ;")')cput-cpus,ll
  endif

  RESETCPU

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

  do ii = 0 , Ni(ll) , Ni(ll) ! loop over sub-grid; ii=0 is inner interface; ii=Ni(ll) is outer interface;

   if( ll.eq.1 .and. ii.eq.0 ) cycle ! dont require field magnitude on coordinate axis;

   io = ii / Ni(ll)
   
   lss = ss(ll)%s(ii) 

   ADDCPU(cb02aa)
   
   if( Wcb02aa ) then ; cput = MPI_WTIME() ; write(ounit,'("cb02aa : "f10.2" : ll="i3" ; calling co01aa ;")')cput-cpus,ll
   endif
   
   Lcurv = 1 ; CALL(co01aa,(lss,Lcurv)) ! will need sg(0,:),,gij(1:6,0,:); note that sg(1:3,:) and gij(1:6,1:3,:) are available as workspace arrays;
   
   if( Wcb02aa ) then ; cput = MPI_WTIME() ; write(ounit,'("cb02aa : "f10.2" : ll="i3" ; called  co01aa ;")')cput-cpus,ll
   endif
   
   if( Wcb02aa ) then ; cput = MPI_WTIME() ; write(ounit,'("cb02aa : "f10.2" : ll="i3" ; calling sa00aa ;")')cput-cpus,ll
   endif

   CALL(sa00aa,(lss)) ! returns radially interpolated Fourier harmonics of vector potential (and derivatives);
   
   if( Wcb02aa ) then ; cput = MPI_WTIME() ; write(ounit,'("cb02aa : "f10.2" : ll="i3" ; called  sa00aa ;")')cput-cpus,ll
   endif
   
   RESETCPU
   
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

!latex \item The contravariant components of \mbox{${\bf B}$} are obtained from \mbox{${\bf B}=\nabla\times(A_\theta\nabla\theta+A_\zeta\nabla\zeta)$}, giving
!latex \be B^\s=\left(\partial_\t A_\z-\partial_\z A_\t\right)/\sqrt g, \qquad
!latex     B^\t=\left(                -\partial_\s A_\z\right)/\sqrt g, \qquad
!latex     B^\z=\left(\partial_\s A_\t                 \right)/\sqrt g, \ee   

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

   efmn(1:mn) =                       -         Azmn(1,1:mn) ! Azmn(1,1:mn) = \partial_s A_z;
   cfmn(1:mn) =           Atmn(1,1:mn)                       ! Atmn(1,1:mn) = \partial_s A_z;
   
   ofmn(1:mn) = zero ; sfmn(1:mn) = zero
   call invfft( mn , im , in , efmn(1:mn) , ofmn(1:mn) , cfmn(1:mn) , sfmn(1:mn) , Nt , Nz , gij(2,1,:) , gij(3,1,:) , isr , trigm , trign , trigwk )
   
  !ofmn(1:mn) = zero ; sfmn(1:mn) = zero
  !call invfft( mn , im , in , efmn(1:mn) , ofmn(1:mn) , cfmn(1:mn) , sfmn(1:mn) , Nt , Nz , gst(1,:) , gsz(1,:) , isr , trigm , trign , trigwk )
   
   gij(2,1,:) = gij(2,1,:) / sg(0,:) ! shall use gij(2,1,:) = B^\t
   gij(3,1,:) = gij(3,1,:) / sg(0,:) ! shall use gij(3,1,:) = B^\z

  !gst(1,:) = gst(1,:) / sg(0,:) ! shall use gij(2,1,:) = B^\t
  !gsz(1,:) = gsz(1,:) / sg(0,:) ! shall use gij(3,1,:) = B^\z
   
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

!latex \item The covariant components of ${\bf B}=B_\s \nabla \s + B_\t \nabla \t + B_\z \nabla \z$
!latex are determined using the lowering metrics, $g_{ij}$,
!latex \be B_\s = B^\s g_{\s\s} + B^\t g_{\s\t} + B^\z g_{\s\z}, \qquad 
!latex     B_\t = B^\s g_{\s\t} + B^\t g_{\t\t} + B^\z g_{\t\z}, \qquad 
!latex     B_\z = B^\s g_{\s\z} + B^\t g_{\t\z} + B^\z g_{\z\z}.
!latex \ee

    gij(2,2,:) =                         gij(2,1,:)*gij(4,0,:) + gij(3,1,:)*gij(5,0,:) ! shall use gij(2,2,:) = B_\t;
    gij(3,2,:) =                         gij(2,1,:)*gij(5,0,:) + gij(3,1,:)*gij(6,0,:) ! shall use gij(3,2,:) = B_\z;

   !gst(2,:) =                         gst(1,:)*gtt(0,:) + gsz(1,:)*gtz(0,:) ! shall use gij(2,2,:) = B_\t;
   !gsz(2,:) =                         gst(1,:)*gtz(0,:) + gsz(1,:)*gzz(0,:) ! shall use gij(3,2,:) = B_\z;
   
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
   
!latex \item The field magnitude is given \be B^2 = B^\s B_\s + B^\t B_\t + B^\z B_\z.\ee

!latex \item The force balance condition depends on the quantity $[[p+B^2/2]]\sqrt g^i$, where $i\equiv$\verb+Iusesg+, 
!latex and on the interfaces $B^s=0$.
   
    ijreal(1:Ntz) = ( pres(ll)*pscale + half * ( gij(2,1,:)*gij(2,2,:) + gij(3,1,:)*gij(3,2,:) ) ) * ( sg(0,:) )**Iusesg! (p + B^2/2) on interfaces;
    
   !ijreal(1:Ntz) = ( pres(ll)*pscale + half * ( gst(1,:)*gst(2,:) + gsz(1,:)*gsz(2,:) ) ) * ( sg(0,:) )**Iusesg! (p + B^2/2) on interfaces;
    
    ijimag(1:Ntz) = swI(1:Ntz) ! swI calculated in above call to sw02aa;
    
    call tfft( Nt,Nz,ijreal(1:Ntz),ijimag(1:Ntz),isr,trigm,trign,trigwk,mn,im(1:mn),in(1:mn),Bdmn(io,1:mn),ofmn(1:mn),cfmn(1:mn),Idmn(1:mn),ifail )

! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! !

!latex \item Constraints on the poloidal angle are derived as follows:
!latex Introducing a new angle defined $\theta=\bar \theta + \sum_k \lambda_k \sin(m_k\bar \theta-n_k\zeta)$, the Fourier spectrum of the interface geometry changes according to
!latex \be \bar R_j &=& \oint \!\! \oint d\bar\theta d\zeta \, R(\theta,\zeta) \cos(m_j\bar\theta-n_j\zeta) ,\\
!latex     \bar Z_j &=& \oint \!\! \oint d\bar\theta d\zeta \, Z(\theta,\zeta) \sin(m_j\bar\theta-n_j\zeta) .\ee

!latex \be \left.\frac{\partial \bar R_j}{\partial \lambda_k}\right|_{\lambda=0} &=&
!latex \oint \!\! \oint d\bar\theta d\zeta R_\theta(\bar \theta,\zeta) \sin(m_k\bar\theta-n_k\zeta) \cos(m_j\bar\theta-n_j\zeta) ,\\
!latex     \left.\frac{\partial \bar Z_j}{\partial \lambda_k}\right|_{\lambda=0} &=&
!latex \oint \!\! \oint d\bar\theta d\zeta Z_\theta(\bar \theta,\zeta) \sin(m_k\bar\theta-n_k\zeta) \sin(m_j\bar\theta-n_j\zeta) .\ee

!latex Now use the angle freedom, $\lambda_k$, to minimize
!latex \be M \equiv \frac{1}{2}\sum_j (m_j^p+n_j^q)\left(\bar R_j^2+\bar Z_j^2\right).\ee

!latex \item Note : this approach is not implemented directly, but should be equivalent, see \verb+sw02aa+ for construction of angle constraints.
   
! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! !
   
!latex \item The normal is 
!latex ${\bf e}_\theta \times {\bf e}_\zeta = R Z_\theta \hat r +
!latex (Z_\theta R_\zeta - R_\theta Z_\zeta) \hat \phi - R R_\theta \hat z$.
   
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

!latex \item From \mbox{$\nabla\times{\bf B}=\mu {\bf B}$}, 
!latex and \mbox{$B^s\equiv{\bf B}\cdot\nabla s=0$} on the interfaces \cite{Hudson_Hole_Dewar_07}, 
!latex we obtain \mbox{$B_\theta=\partial_\theta f$} and \mbox{$B_\zeta = \partial_\zeta f$} 
!latex where \be f=I\theta-G\zeta+\sum_{m,n}f_{mn}\sin(m\theta-n\zeta).\ee
!latex This representation is constructed by (Fourier) integrating $B_\theta$ and $B_\zeta$.

!latex \item If \verb+( Lsetmupf .and. Lwrpj )+, this routine writes the \verb+ext.suff.pj+ files.
!latex The quantities \mbox{$I$}, \mbox{$G$}, and the \mbox{$f_{mn}$}'s are saved, along with the interface geometry.

    if( Lsetmupf .and. Iwrpj ) then ! only in this case is (mu,dpflux) adjusted to match prescribed transform;
    
!compute harmonics of B_\theta, B_\zeta; be careful not to corrupt jireal and jiimag;
    call tfft( Nt , Nz , gij(2,2,:), gij(3,2,:) , isr , trigm , trign , trigwk , mn , im , in , efmn(1:mn) , ofmn(1:mn) , cfmn(1:mn) , sfmn(1:mn) , ifail )

   !call tfft( Nt , Nz , gst(2,:), gsz(2,:) , isr , trigm , trign , trigwk , mn , im , in , efmn(1:mn) , ofmn(1:mn) , cfmn(1:mn) , sfmn(1:mn) , ifail )
    
    Itor(ll,io) = efmn(1) ; Gpol(ll,io) = cfmn(1) ! secular terms;
    do imn = 1,mn
     if( im(imn).eq.0 .and. in(imn).eq.0 ) spmn(ll,io,imn) = zero
     if( im(imn).eq.0 .and. in(imn).ne.0 ) spmn(ll,io,imn) =                          - cfmn(imn)/in(imn)
     if( im(imn).ne.0 .and. in(imn).eq.0 ) spmn(ll,io,imn) =        efmn(imn)/im(imn)                        
     if( im(imn).ne.0 .and. in(imn).ne.0 ) spmn(ll,io,imn) = half*( efmn(imn)/im(imn) - cfmn(imn)/in(imn) )
    enddo
    
    lli = ll-1 + io ! shorthand; 
    write(suff,'(i3.3":"i1)')ll,io    
    open(irrationunit+myid,file="."//trim(ext)//"."//suff//".pjh",status="unknown")
    write(irrationunit+myid,'(3i6)')Mpol,Ntor,Nfp
    write(irrationunit+myid,'(2es23.15,4i6,es23.15)')Itor(ll,io),Gpol(ll,io),pl(lli),ql(lli),pr(lli),qr(lli),(pl(lli)+goldmean*pr(lli))/(ql(lli)+goldmean*qr(lli))
    write(irrationunit+myid,'(2i6,3es23.15)')(im(imn),in(imn),spmn(ll,io,imn),Rbc(lli,0,imn),Zbs(lli,0,imn),imn=1,mn)
    close(irrationunit+myid)
    
   endif ! end of if ( ( ii.eq.0 .or. ii.eq.Ni(ll) ) .and. Lsetmupf .and. Iwrpj ) then 
   
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
   
!latex \item The remaining covariant component is given \mbox{$B_s=(B^s-g^{s,\theta}B_\theta-g^{s,\zeta}B_\zeta)/g^{ss}$}.
!latex This allows the expression
!latex \be B^2 = \frac{ g_{\zeta\zeta} B_\theta B_\theta + 2 g_{\theta\zeta} B_\theta B_\zeta + g_{\theta\theta} B_\zeta B_\zeta}
!latex                {\sqrt g \, \sqrt g \, g^{ss}}.\ee
!latex NOTE: this should be checked!!!!

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

  enddo ! end of do ii=0,Ni(ll),Ni(ll) loop over inner and outer interfaces
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
  RETURN(cb02aa)
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
end subroutine cb02aa

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
