!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

!latex \item Prepare field-line tracing information for anisotropic-diffusion calculation.

subroutine hr00aa
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
  use constants, only : zero, one, pi2
  use numerical, only :
  use fileunits, only : ounit, poincareunit
  use inputlist, only : Whr00aa, ext, Ni, odetol
  use cputiming, only : Thr00aa
  use allglobal, only : myid, cpus, pi2nfp, ll, ss, ifb
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
  LOCALS

  INTEGER   :: Nhi=8, Nhj=8 ! this should be user input;
  
  INTEGER   :: Node, ii, jj, kbf, d02bjfifail
  REAL      :: tol, st(6), zst, zend, work6(20*6)
  CHARACTER :: RA, suf*4
  
  external :: bf00aa, bf00aa_out, bf00aa_end
  
  BEGIN(hr00aa)
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
  write(suf,'(i4.4)')ll
  open(poincareunit+myid,file="."//trim(ext)//".metrics:"//suf,status="unknown",form="unformatted") ! this will contain Poincare plot data; 
  write(poincareunit+myid)ss(ll)%s(0),ss(ll)%s(Ni(ll)) ! identify annulus;
  write(poincareunit+myid)Nhi,Nhj ! #toroidal planes;
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
  Node=6 ; RA='D' ; tol=odetol
  
  do jj = 1 , Nhj-1
   do ii = 0 , Nhi-1
    
    do ifb = -1,1,2 ! backward/forward along field line;
     
     st(1:6) = (/ ss(ll)%s(0) + jj * ( ss(ll)%s(Ni(ll)) - ss(ll)%s(0) ) / Nhj , ii * pi2 / Nhi , one , zero , zero , one /)
     
     do kbf = 1,2
      
      zst = zero ; zend = zst + ifb*pi2nfp
      
      d02bjfifail=1
      CALL(D02BJF,(zst,zend,Node,st,bf00aa,tol,RA,bf00aa_out,bf00aa_end,work6,d02bjfifail))
      
      FATAL(hr00aa : d02bjf input error                  ,d02bjfifail.eq.1)
      FATAL(hr00aa : d02bjf error integrating along field,d02bjfifail.eq.2)
      FATAL(hr00aa : d02bjf tol is too small             ,d02bjfifail.eq.3)
      FATAL(hr00aa : d02bjf xsol not reset after output  ,d02bjfifail.eq.4)
      FATAL(hr00aa : d02bjf xsol lies past xend          ,d02bjfifail.eq.5) 
      FATAL(hr00aa : d02bjf did not change sign          ,d02bjfifail.eq.6)
      FATAL(hr00aa : d02bjf serious error                ,d02bjfifail.eq.7)
  
      write(poincareunit+myid)st(1:2)  

     enddo ! end of kbf loop;
   
    enddo ! end of ifb loop;
    
   enddo ! end of ii loop;
  enddo ! end of jj loop;
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

  close(poincareunit+myid)

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

  RETURN(hr00aa)
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
end subroutine hr00aa

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

!   if(myid.eq.0) then
!    open(munit,file="."//trim(chiijfile)//":"//suff//".metrics",status='unknown',form='unformatted')
!    write(munit,iostat=ios)iNi,iNj,iNk,odetol
!    FATAL(metrics  : error writing iNi iNj iNk to .metrics,ios.ne.0)
!    write(munit,iostat=ios)Bfh
!    FATAL(metrics  : error writing to Bfh .metrics,ios.ne.0)
!   !write(munit)dxydabf
!    write(munit,iostat=ios)dxydabf(1,0:0,-4:4:2,0:Ni-1,0:Nj,0:Nk-1)
!    FATAL(metrics  : error writing dxydabf(1  ) to .metrics,ios.ne.0)
!    write(munit,iostat=ios)dxydabf(2,0:0,-4:4:2,0:Ni-1,0:Nj,0:Nk-1)
!    FATAL(metrics  : error writing dxydabf(2  ) to .metrics,ios.ne.0)
!   !write(munit)dxydabh
!    close(munit)
!   endif
