!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

!latex \item Deallocates geometric information,
!latex matches \verb+ma00ab+.

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

subroutine ma00ac

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

  use constants, only : 
  use numerical, only : 
  use fileunits, only : ounit
  use inputlist, only : Wma00ac, Nofe
  use cputiming, only : Tma00ac
  use allglobal, only : myid, cpus, mn, ll, igss, igst, igsz, igtt, igtz, igzz, igoo, sgss, sgst, sgsz, sgtt, sgtz, sgzz, sgoo

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

  LOCALS
  
  INTEGER :: il, ip, ir, iq, ij, ik, jk, imj, imk
  
  BEGIN(ma00ac)
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
  if( Wma00ac ) then ; cput = MPI_WTIME() ; write(ounit,'("ma00ac : "f10.2" : ll="i3" ;")')cput-cpus,ll
  endif
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
  do il = 0,1 ! left, right basis function;
   do ip = 0,Nofe ! basis function; derivative;
    
    do ir = 0,1 ! left, right basis function;
     do iq = 0,Nofe ! basis function; derivative;
      
      jk = 0 
      
      do ij = 1,mn
       do ik = 1,mn ; jk = jk + 1
        
        DEALLOCATE(igss(il,ip,ir,iq,jk)%s)
        DEALLOCATE(igst(il,ip,ir,iq,jk)%s)
        DEALLOCATE(igsz(il,ip,ir,iq,jk)%s)
        DEALLOCATE(igtt(il,ip,ir,iq,jk)%s)
        DEALLOCATE(igtz(il,ip,ir,iq,jk)%s)
        DEALLOCATE(igzz(il,ip,ir,iq,jk)%s)
        DEALLOCATE(igoo(il,ip,ir,iq,jk)%s)  
        
        if( ll.eq.1 ) then 

         do imj = 0, 1
          do imk = 0 , 1
           DEALLOCATE(sgss(1+imj+2*imk,il,ip,ir,iq,jk)%s)
           DEALLOCATE(sgst(1+imj+2*imk,il,ip,ir,iq,jk)%s)
           DEALLOCATE(sgsz(1+imj+2*imk,il,ip,ir,iq,jk)%s)
           DEALLOCATE(sgtt(1+imj+2*imk,il,ip,ir,iq,jk)%s)
           DEALLOCATE(sgtz(1+imj+2*imk,il,ip,ir,iq,jk)%s)
           DEALLOCATE(sgzz(1+imj+2*imk,il,ip,ir,iq,jk)%s)
           DEALLOCATE(sgoo(1+imj+2*imk,il,ip,ir,iq,jk)%s)
          enddo
         enddo

        endif ! end of if( ll.eq.1 );

       enddo ! end of do ik;
      enddo ! end of do ij;
      
      FATAL(ma00ac,jk.ne.mn*mn)
      
     enddo ! end of do iq;
    enddo ! end of do ir;
    
   enddo ! end of do ip;
  enddo ! end of do il;
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

  RETURN(ma00ac)

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
end subroutine ma00ac

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!


