!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!latex \item Construct Poincare plot for pressure-jump Hamiltonian.

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

subroutine ph01aa
  
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
  
  use constants, only : zero,one,pi2,half,quarter
  use fileunits, only : ounit,irrationunit
  use inputlist, only : Wph01aa, ext,Nvol,Ni,odetol,nPtrj,nPpts,pres,pscale
  use cputiming, only : Tph01aa
  use allglobal, only : myid,numprocs,ll,cpus,pi2nfp,mn,im,in,Rbc,Zbs,Rmn,Zmn,ss
  
  use pjhamilto, only : io,Itor,Gpol,spmn
  
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
  
  LOCALS
  
  INTEGER :: Node, itrj, jpts, id02bjf, lli, oio, ioi, imn, lnPtrj
  REAL :: phi, ptt(6), dptt(6), wk6(20*6), tol, zst, zend, pto, sumerr(2), presi, preso
  CHARACTER :: RA, suff*5
  
  external :: ph00aa, ph00aa_out, ph00aa_end
  
  BEGIN(ph01aa)
  
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

  if( nPtrj(ll).ge.0 ) then ; lnPtrj = nPtrj(ll) ! selected Poincare resolution;
  else                      ; lnPtrj = Ni(ll)    ! adapted  Poincare resolution;
  endif
  
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
  
  Node = 6 ; tol = odetol ; RA='D'

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

  do io = 0,1 ! inner and outer interface for each volume; needs to be passed through to ph00aa (via pjhamilto module);
   
   if( ll.eq.  1  .and. io.eq.0 ) cycle
   if( ll.eq.Nvol .and. io.eq.1 ) cycle

   lli = ll-1 + 2*io ; oio = 1-io ; ioi = ll+io-1 ! shorthand; 

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

   presi=pres(ll)*pscale ; preso=pres(lli)*pscale

   call pj00aa(mn,Rbc(ioi,0,1:mn),Zbs(ioi,0,1:mn),Itor(ll,io),Gpol(ll,io),spmn(ll,io,1:mn),presi,Itor(lli,oio),Gpol(lli,oio),spmn(lli,oio,1:mn),preso,sumerr(1:2))

   cput = MPI_WTIME()
   write(ounit,1001)cput-cpus,myid,ll,io,sumerr(1:2),sumerr(2)/sumerr(1),lnPtrj
1001 format("ph01aa : "f10.2" : myid="i3" ; ll="i3" ; io="i2" ; <<2p+BB>>, [[2p+BB]]="2es13.5" , "es13.5" ; lnPtrj="i4" ;")
   
   if( lnPtrj.le.0 ) cycle ! don't construct Poincare plot;

   pto = Itor(lli,oio)
   do imn = 1,mn ; pto = pto + spmn(lli,oio,imn) * im(imn) ! * cos( im(imn)*zero -in(imn)*zero )
   enddo
   
   write(suff,'(i3.3":"i1)')ll,io    

   open(irrationunit+myid,file="."//trim(ext)//".pjh:"//suff,status="unknown")
!   open(irrationunit+myid,file="."//trim(ext)//".pjh:"//suff,status="unknown",form="unformatted")
   
   write(irrationunit+myid,'(i9,3es23.15)')mn,Itor(lli,oio),Gpol(lli,oio),pto
   write(irrationunit+myid,'(2i9,es23.15)')(im(imn),in(imn),spmn(lli,oio,imn),imn=1,mn)
!   write(irrationunit+myid)mn,Itor(lli,oio),Gpol(lli,oio),pto
!   write(irrationunit+myid)im(1:mn)
!   write(irrationunit+myid)in(1:mn)
!   write(irrationunit+myid)spmn(lli,oio,1:mn)

   do itrj = -lnPtrj,lnPtrj

    ptt = (/ pto + itrj * pto * quarter / lnPtrj, zero , one , zero , zero , one /)
    
    do jpts = 1,nPpts
     
     zst=zero ; zend=zst + pi2nfp ; id02bjf=1
     CALL(D02BJF,( zst , zend , Node , ptt , ph00aa , tol , RA , ph00aa_out , ph00aa_end , wk6 , id02bjf ))
     
     ptt = (/ ptt(1) , mod(ptt(2),pi2) , one , zero , zero , one /)
     
     write(irrationunit+myid,'(2es23.15,i9)')ptt(1:2),itrj
!     write(irrationunit+myid)ptt(1:2),itrj
     
     FATAL(ph01aa : d02bjf input error            ,id02bjf.eq.1)
     FATAL(ph01aa : d02bjf error integrating field,id02bjf.eq.2)
     FATAL(ph01aa : d02bjf tol is too small       ,id02bjf.eq.3)
     FATAL(ph01aa : d02bjf xsol not reset         ,id02bjf.eq.4)
     FATAL(ph01aa : d02bjf xsol lies past xend    ,id02bjf.eq.5)
     FATAL(ph01aa : d02bjf did not change sign    ,id02bjf.eq.6)
     FATAL(ph01aa : d02bjf serious error          ,id02bjf.eq.7)
     
    enddo ! end of do jpts
    
   enddo ! end of do itrj
   
   close(irrationunit+myid)
   
  enddo ! end of do io = 0,1;
  
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
  
  RETURN(ph01aa)
  
end subroutine ph01aa

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
