!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

!latex \item Constructs, and fits smooth curve to, periodic orbits.

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

subroutine pq01aa

  use constants
  use fileunits
  use inputlist, only : Wpq01aa, Nfp, p1,q1,p2,q2,npq,Ni,irrMpol,ext,pl,ql,pr,qr,Mirrits
  use cputiming, only : Tpq01aa
  use allglobal, only : ll,cpus,ss,irrsurf,pqorbit,myid,irrmn,irrim,irrin

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

  LOCALS 

  INTEGER              :: i, k, m, nc, ncok, ifail, pp, qq, M1, M2, imn
  REAL                 :: err, Tsti(6), low, upp, lu(2), iotal, iotau, iota

  INTEGER, allocatable :: ik(:) ! ranking;
  REAL   , allocatable :: lds(:), ldt(:), a(:), s(:), t(:)

  CHARACTER            :: ascend, suff*15
  
  BEGIN(pq01aa)

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
!latex \item This routine prepares initial guesses for the location of the periodic orbits,  
!latex which are found \verb+pq00aa+ by field line following.
!latex Periodicities are selected in input file, $(p_1,q_1,p_2,q_2)=$\verb!pqirr(1:4,:)!.
!latex Beginning from these rationals (which should be neighboring), \verb!pqirr(5,:)! mediants will also be located ;
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
  low=ss(ll)%s(0) ; upp=ss(ll)%s(Ni(ll)) ; lu=(/ low , upp /) ! ; p(1:2) = (/0,0/) ; q(1:2) = (/0,0/) ! initialize;

  iotal = ( pl(ll-1) + goldmean * pr(ll-1) ) / ( ql(ll-1) + goldmean * qr(ll-1) ) ! search bound;
  iotau = ( pl(ll  ) + goldmean * pr(ll  ) ) / ( ql(ll  ) + goldmean * qr(ll  ) ) ! search bound;
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

  ncok = 0 ! this counts how many rationals were within transform range;
 
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

  do nc = 1,npq(ll) ; pp = pqorbit(ll,nc)%pq(1) ; qq = pqorbit(ll,nc)%pq(2) ; iota =  ( pp * Nfp ) * one / qq! loop over convergent rationals;
   
!   if( ( pp*one/qq - (pl(ll-1)+goldmean*pr(ll-1))/(ql(ll-1)+goldmean*qr(ll-1)) ) &
!     * ( pp*one/qq - (pl(ll  )+goldmean*pr(ll  ))/(ql(ll  )+goldmean*qr(ll  )) ) .ge. zero ) then
!    cput = MPI_WTIME()
!    if( WF(3) ) write(ounit,1001)cput-cpus,myid,ll,pp,qq,pp*one/qq
!1001 format("pq01aa : "f10.2" : WF(3) ; myid="i3" ; ll="i3" ; "i3" /"i4" ="f9.6" ; not in range ;")
!    cycle
!   else
!    ncok=ncok+1
!   endif

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

   if( ( iota - iotal ) * ( iota - iotau ) .ge. zero ) then
    
    cput = MPI_WTIME() ; write(ounit,1001)cput-cpus,myid,ll,pp,qq,pp*one/qq

    cycle

1001 format("pq01aa : "f10.2" : myid="i3" ; ll="i3" ; "i3" /"i4" ="f9.6" ; not in range ;")
    
   else
    
    ncok=ncok+1
    
   endif

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

   if( ncok.gt.2 ) then
    if( abs(pqorbit(ll,nc-1)%res).gt.one ) exit ! residues are getting too large; irrational surface unlikely to exist;
   endif
   
   if( ncok.gt.2 ) then ; low=minval(lu) ; upp=maxval(lu)
   endif
  
   Tsti(1:6)=(/ half*(low+upp) , zero , one , zero , zero , one /) ! estimate starting point by linear interpolation;
  
   if( pqorbit(ll,nc)%so .gt. zero ) Tsti(1)=pqorbit(ll,nc)%so
 
   call pq00aa(pp,qq,low,Tsti(1:6),upp,pqorbit(ll,nc)%res,m,err,pqorbit(ll,nc)%s(0:qq),pqorbit(ll,nc)%t(0:qq),ifail)
   pqorbit(ll,nc)%a(0:qq)=(/(k,k=0,qq)/)*pp*pi2/qq
   
   pqorbit(ll,nc)%so=pqorbit(ll,nc)%s(0) ; pqorbit(ll,nc)%to=pqorbit(ll,nc)%t(0) ! save for plotting;
   
   if( ifail.ne.0 ) exit
   
   lu(1:2)=(/ lu(2) , Tsti(1) /) ! bounds for further searches; successive convergents should bound the irrational;

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
   
  enddo ! end of do nc=1,npq(ll)
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
  if( Mirrits.le.0 ) then
   goto 9999
  !RETURN(pq01aa) ! irrational surfaces is not required;
  endif
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
  write(suff,'(i2.2":"i2.2":"i2.2":"i2.2":"i3.3)')p1(ll),q1(ll),p2(ll),q2(ll),irrMpol
  
  open(periodicunit,file="."//trim(ext)//"."//suff//".pq_irr",status="unknown") ! this file is completed below, after ir00aa is called;
  write(periodicunit,'(3i9)')npq(ll),irrMpol,irrmn
  do nc=1,npq(ll) ; qq=pqorbit(ll,nc)%pq(2)
   write(periodicunit,'(2i6,es23.15)')pqorbit(ll,nc)%pq(1:2),pqorbit(ll,nc)%res
   write(periodicunit,'(2es23.15)')(pqorbit(ll,nc)%t(i),pqorbit(ll,nc)%s(i),i=0,qq)
  enddo
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
!latex \item Approximating periodic orbits provide initial guess for irrational surface.
  
  do nc=npq(ll),1,-1 ; qq=pqorbit(ll,nc)%pq(2)
   
   if( abs(pqorbit(ll,nc)%res).lt.one ) then
    
    pqorbit(ll,nc)%t(0:qq) = pqorbit(ll,nc)%t(0:qq) - pqorbit(ll,nc)%a(0:qq) ! lambda;
    
    pqorbit(ll,nc)%a(0:qq) = modulo(pqorbit(ll,nc)%a(0:qq),pi2) ; pqorbit(ll,nc)%a(qq)=pi2 ! mapped back to [0,pi2];
    
    M1=1 ; M2=qq+1 ; ascend="A" ; M=2*irrMpol
    
!latex The periodic orbits are re-ordered,
    
    ALLOCATE(ik,(M2)) ! ranking;
    ifail=0 ; call M01DAF( pqorbit(ll,nc)%a(0:qq) , M1 , M2 , ascend , ik , ifail ) ! determine ranking;
    ifail=0 ; call M01EAF( pqorbit(ll,nc)%a(0:qq) , M1 , M2 ,          ik , ifail ) ! re-arrange according to rank;
    ifail=0 ; call M01EAF( pqorbit(ll,nc)%s(0:qq) , M1 , M2 ,          ik , ifail ) ! re-arrange according to rank;
    ifail=0 ; call M01EAF( pqorbit(ll,nc)%t(0:qq) , M1 , M2 ,          ik , ifail ) ! re-arrange according to rank;
    DEALLOCATE(ik)
    
    ALLOCATE(lds,(0:qq))
    ALLOCATE(ldt,(0:qq))
    
!latex and a smooth curve (cubic-hermite) is fit,
    
    ifail=0 ; call E01BEF( M2 , pqorbit(ll,nc)%a(0:qq) , pqorbit(ll,nc)%s(0:qq) , lds(0:qq) , ifail ) ! cubic-interpolation;
    ifail=0 ; call E01BEF( M2 , pqorbit(ll,nc)%a(0:qq) , pqorbit(ll,nc)%t(0:qq) , ldt(0:qq) , ifail ) ! cubic-interpolation;
    
    ALLOCATE(a,(0:M-1))
    ALLOCATE(s,(0:M-1))
    ALLOCATE(t,(0:M-1))
    
    a(0:M-1)=(/(k,k=0,M-1)/)*pi2/M
    
! cubic-interpolation;
    ifail=0 ; call E01BFF( M2 , pqorbit(ll,nc)%a(0:qq) , pqorbit(ll,nc)%s(0:qq) , lds(0:qq) , M , a(0:M-1) , s(0:M-1) , ifail )
    ifail=0 ; call E01BFF( M2 , pqorbit(ll,nc)%a(0:qq) , pqorbit(ll,nc)%t(0:qq) , ldt(0:qq) , M , a(0:M-1) , t(0:M-1) , ifail )
    
    DEALLOCATE(a)
    DEALLOCATE(lds)
    DEALLOCATE(ldt)
    
!latex and a Fourier decomposition is constructed.
    
    ifail=0 ; call C06EAF( s(0:M-1) , M , ifail ) ; s(0:M-1) = s(0:M-1)/sqrt(one*M) ; s(1:M-1) = s(1:M-1)*two
    ifail=0 ; call C06EAF( t(0:M-1) , M , ifail ) ; t(0:M-1) = t(0:M-1)/sqrt(one*M) ; t(1:M-1) = t(1:M-1)*two
    
!latex The Fourier harmonics of the `periodic-{\em curve}' is used as an initial guess 
!latex for the construction of the irrational invariant curves.
    
    irrsurf%sm(0:irrMpol) = zero ; irrsurf%sm(0:irrMpol-1) =  s(  0:  irrMpol-1   )
    irrsurf%tm(1:irrMpol) = zero ; irrsurf%tm(1:irrMpol-1) = -t(M-1:M-irrMpol+1:-1)
    
    DEALLOCATE(s)
    DEALLOCATE(t)
    
    exit ! only need the closest approximation; is it possible to extrapolate to the irrational?;
    
   endif
   
  enddo ! end of nc loop;
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
!latex \item Irrational surfaces are located via a call to \verb+ir00aa+. The irrationalities are selected in input file, 
!latex \be \iotabar=(p_1+\gamma p_2) / (q_1+\gamma q_2), \ee
!latex with $(p_1,q_1,p_2,q_2)=$\verb!pqirr(1:4,n)!.
!latex \item The variable \verb+irrsurf+ is passed through global memory.
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

  irrsurf%iota = ( p1(ll) + goldmean * p2(ll) ) / ( q1(ll) + goldmean * q2(ll) )
  
  call ir00aa ! NOTE : irrsurf is passed through via common module;
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
  write(periodicunit,'(i6,2es24.16)')(m,irrsurf%tm(m),irrsurf%sm(m),m=0,irrMpol) ! irrational surface: intersection with zeta=0;
  do imn=1,irrmn ; write(periodicunit,'(2i6,2es23.15)')irrim(imn),irrin(imn),irrsurf%Rbc(imn),irrsurf%Zbs(imn)
  enddo
  close(periodicunit) ! this file is opened above;
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
  RETURN(pq01aa)

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

1003 format("pq01aa : "9x"  : iv="i3" ; inner transform="f9.5" ="f9.5" +"es10.2" ; outer transform="f9.5" ="f9.5" +"es10.2" ;")

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

end subroutine pq01aa

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!


!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

!REAL function bfend(iz,Tst) ! termination of field line integration;
!
!  use allglobal,only : pi2nfp
!
!  implicit none
!
!  REAL, intent(in) :: iz,Tst(6)
!
!  bfend = iz - pi2nfp
!
!  return
!
!end function bfend

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!



