!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

!latex \item Constructs quadratic-flux minimizing surfaces.
!latex \item The routine \verb+pq02aa+ is called from \verb+spec+, and only if \verb+Nghd.gt.0+.
!latex       The \verb+qfmin+ structure array is defined in \verb+global+ and allocated (and assigned default values) in \verb+al0aa+.

subroutine pq02aa
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
  use constants, only : zero, one, two, pi, pi2, goldmean
  use numerical, only :
  use fileunits, only : ounit, qfmsunit
  use inputlist, only : Wpq02aa, ext, Nfp, pscale, Ni, npq, Nghd, Mpqits, odetol, pl, ql, pr, qr
  use cputiming, only : Tpq02aa
  use allglobal, only : myid, cpus, pi2nfp, ll, ss, Nz, pqorbit, pqorbit, qfms, jgd, kgd, actiongradient
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
  LOCALS
  
  INTEGER            :: pp, qq, nc, its, nqq, id02bjf, Node, itgt, npmodq, isfla, ii, jgdmin, ifail, fNghd
  REAL               :: low, upp, lu(2), ti, ri, acti, dr, dv, tm(2, 2), st, tt, rr, err, tol, wk(7*20), trd(7), rto(7), acto, rtd(7), rtm(7), xt, xe, dfd=1.0e-04
  REAL               :: det, iotal, iotau, iota, ts, sflerr, xx, shear
  REAL,  allocatable :: nu(:)
  CHARACTER          :: relabs, suf*4
  EXTERNAL           :: pfield, bf00aa_out, bf00aa_end
  
  BEGIN(pq02aa)
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
  Node = 7 ; relabs = 'D' ; tol = odetol ; fNghd = 4*Nghd
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

  low = ss(ll)%s(0) ; upp = ss(ll)%s(Ni(ll)) ; lu = (/ low , upp /)

  iotal = ( pl(ll-1) + goldmean * pr(ll-1) ) / ( ql(ll-1) + goldmean * qr(ll-1) ) ! search bound;
  iotau = ( pl(ll  ) + goldmean * pr(ll  ) ) / ( ql(ll  ) + goldmean * qr(ll  ) ) ! search bound;

  shear = ( iotau-iotal ) / ( upp-low)
   
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
  do nc = 1,npq(ll) ; pp = pqorbit(ll,nc)%pq(1) ; qq = pqorbit(ll,nc)%pq(2) ; iota = pp*Nfp *one/qq ! loop over convergent rationals;

   cput = MPI_WTIME() ; write(ounit,'("pq02aa : "f10.2" : myid="i3" ; ll="i3" ; "i3" /"i4" ="f9.6" ;")')cput-cpus,myid,ll,pp,qq,pp*one/qq

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
   
!latex \item If the selected rational is within the rotational transform range of the given annulus, the flag \verb+qfms(ll,nc)%i=1+ is set. 
!latex This will be used in \verb+pp00aa+ when constructing the \Poincare plot.
!latex If the selected rational is not within the rotational transform range of the given annulus, control will cycle.

! the following line will encounter an error if npq(ll).gt.1 ;

!FATAL(pq02aa : too many convergents : need to re-define qfms structure,nc.ne.1)
   
   qfms(ll,nc)%pq(1:2)=(/ pp , qq /)
   
   ALLOCATE(qfms(ll,nc)%trvs,(1:4,0:fNghd,0:qq)) ! full family of full periodic pseudo curves;
   qfms(ll,nc)%trvs=zero
   
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
   
   if( ( iota - iotal ) * ( iota - iotau ) .ge. zero ) then
    
    cput = MPI_WTIME() ; write(ounit,1001)cput-cpus,myid,ll,pp,qq,pp*one/qq
    
    cycle
    
1001 format("pq02aa : "f10.2" : myid="i3" ; ll="i3" ; "i3" /"i4" ="f9.6" ; not in range ;")
    
   endif
   
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
   
   qfms(ll,nc)%i = 1 ; qfms(ll,nc)%pq(1:2)=(/ pp , qq /)
   
   do npmodq=1,qq-1
    if( mod( npmodq * pp , qq ).eq.1 ) exit ! periodicity;
   enddo
   
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

!latex \item The qfmin-surface is constructed iteratively (at max. \verb+Mpqits+) in order to obtain periodic pseudo curves equally spaced in the straight-field line angle.

   do isfla = 0,Mpqits
    
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
    
    if( isfla.eq.0 ) jgdmin = 0
    if( isfla.gt.0 ) jgdmin = 0 ! no need to recompute? careful with shifting!!!

    do jgd = jgdmin,fNghd-1 ! for each periodic pseudo orbit; NOTE : should be jgd=tNgd from periodicity; poloidal index;
     
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
     
     if( isfla.eq.0 ) then ! no previous estimate of straight field line angle is available;
      
      if( jgd.eq.0 ) then ; ti = zero                                                    ; ri = pqorbit(ll,nc)%so           ; acti = zero
      else                ; ti = jgd * mod( qfms(ll,nc)%trvs(1,0,npmodq) , pi2 ) / fNghd ; ri = qfms(ll,nc)%trvs(2,jgd-1,0) ; acti = qfms(ll,nc)%trvs(3,jgd-1,0)
      endif
      
     else ! can estimate location of straight field line angle;
      
      ts = jgd * ( pi2/qq ) / fNghd
      
      do ii = 0,fNghd-1
       
       if( ts.ge.qfms(ll,nc)%trvs(4,ii,0) .and. ts.le.qfms(ll,nc)%trvs(4,ii+1,0) ) then
        
        xx = ( ts - qfms(ll,nc)%trvs(4,ii,0) ) / ( qfms(ll,nc)%trvs(4,ii+1,0) - qfms(ll,nc)%trvs(4,ii,0) )
        
        ti   = qfms(ll,nc)%trvs(1,ii,0) + ( qfms(ll,nc)%trvs(1,ii+1,0)-qfms(ll,nc)%trvs(1,ii,0) ) * xx
        ri   = qfms(ll,nc)%trvs(2,ii,0) + ( qfms(ll,nc)%trvs(2,ii+1,0)-qfms(ll,nc)%trvs(2,ii,0) ) * xx
        acti = qfms(ll,nc)%trvs(3,ii,0) + ( qfms(ll,nc)%trvs(3,ii+1,0)-qfms(ll,nc)%trvs(3,ii,0) ) * xx
        
        exit
        
       endif

      enddo
      
     endif
     
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

!latex \item Each periodic pseudo orbit is located by integrating the pseudo-field the full periodicity and using an iterative method.

     its = 0 ; dr = zero ; dv = zero
     
     do ; its = its+1 ! iterate to locate periodic-pseudo orbit;
      
      ri = ri + dr ; acti = acti + dv ! update guess;
      
      rto = (/ ri , ti , zero , zero , zero , one , zero /) ; acto = acti
      
      kgd = 0 ; qfms(ll,nc)%trvs(1:3,jgd,kgd) = (/ ti , ri , acti /)
      
!latex \item The tangent mapping is constructed by finite-differences (but a better approach could construct the tangent map by integrating the differentiated equations).

      do itgt = 0,2 ! compute tangent matrix by finite-differences;
       
       rtd(1:7) = rto(1:7) ; actiongradient = acto
       
       if( itgt.eq.1 ) rtd(1)         = rto(1) + dfd
       if( itgt.eq.2 ) actiongradient =  acto  + dfd

       ADDCPU(pq02aa)       

       do nqq = 1 , qq ! full q-period mapping; note that for the symmetric periodic pseudo orbit = periodic true orbit, only need to follow half periodicity distance;
        
        xt = zero ; xe = xt + pi2nfp ; id02bjf = 0 ; call D02BJF( xt , xe , Node , rtd , pfield , tol , relabs , bf00aa_out , bf00aa_end , wk , id02bjf )
        
!latex \item The periodic pseudo orbits are presently only saved on one toroidal plane -- this needs to be developed if the qmfin surface is to be Fourier decomposed.
        
        if( itgt.eq.0 ) then ; kgd = kgd+1 ; qfms(ll,nc)%trvs(1:3,jgd,kgd) = (/ rtd(2) , rtd(1) , acti /)
        endif
        
       enddo

       RESETCPU
       
       if( itgt.eq.0 ) qfms(ll,nc)%trvs(4,jgd,0) = rtd(7) / ( pi2 * qq ) - pp * pi ! straight field line angle;
       
       if( itgt.eq.0 ) rtm(1:7) = rtd(1:7) ! original mapped;
       
       if( itgt.gt.0 ) tm(1:2,itgt) = ( rtd(1:2) - rtm(1:2) ) / dfd ! tangent map;
       
      enddo ! end of do itgt=0,2;
      
      err = sqrt( (rto(1)-rtm(1))**2 + (rto(2)+pi2*pp-rtm(2))**2 )
      
      tm(1,1) = tm(1,1) - one ! periodicity requirement;
      
      det = ( tm(1,1)*tm(2,2) - tm(1,2)*tm(2,1) )
      
      dr = (  tm(2,2) * (rto(1)-rtm(1)) - tm(1,2) * (rto(2)+pi2*pp-rtm(2)) ) / det ! determine correction;
      dv = ( -tm(2,1) * (rto(1)-rtm(1)) + tm(1,1) * (rto(2)+pi2*pp-rtm(2)) ) / det ! determine correction;
      
!latex \item Periodic pseudo orbits are located to a tolerance of \verb+qq*odetol+, or the iterations are terminated if \verb+its.gt.Mpqits+.

      if( err.lt. qq*odetol .or. its.gt.Mpqits ) exit ! converged, or failed;
      
     enddo ! end of do ; its = its+1 loop;
     
    !cput = MPI_WTIME() ; write(ounit,1002)cput-cpus,myid,pp,qq,ti,its,rto(1),acto,err
     
    enddo ! end of do jgd=0,tNgd-1 loop;

    qfms(ll,nc)%trvs(1,fNghd,0)   = mod( qfms(ll,nc)%trvs(1,0,npmodq) , pi2 ) ! add periodic curve; theta;
    qfms(ll,nc)%trvs(2,fNghd,0)   = qfms(ll,nc)%trvs(2,0,npmodq)              ! add periodic curve; radial;
    qfms(ll,nc)%trvs(3,fNghd,0)   = qfms(ll,nc)%trvs(3,0,0)                   ! add periodic curve; action-gradient;
    qfms(ll,nc)%trvs(4,fNghd,0)   = qfms(ll,nc)%trvs(4,0,0) + pi2/qq          ! add periodic curve; theta_s;

   !do iq=0,qq-1
   ! qfms(ll,nc)%trvs(1,fNghd+iq,0)   = qfms(ll,nc)%trvs(1,iq,npmodq) - (npmodq * pp - 1) * pi2 / qq ! add periodic curve; theta;
   ! qfms(ll,nc)%trvs(2,fNghd+iq,0)   = qfms(ll,nc)%trvs(2,iq,npmodq)                                ! add periodic curve; radial;
   ! qfms(ll,nc)%trvs(3,fNghd+iq,0)   = qfms(ll,nc)%trvs(3,iq,0)                                     ! add periodic curve; action-gradient;
   ! qfms(ll,nc)%trvs(4,fNghd+iq,0)   = qfms(ll,nc)%trvs(4,iq,0) + pi2/qq                            ! add periodic curve; theta_s;
   !enddo

    qfms(ll,nc)%trvs(4,0:fNghd,0) = qfms(ll,nc)%trvs(4,0:fNghd,0)-qfms(ll,nc)%trvs(4,0,0) ! recenter;
    
    sflerr = sum( abs( qfms(ll,nc)%trvs(4,0:fNghd-1,0) - (/(jgd,jgd=0,fNghd-1)/)*pi2/qq/fNghd ) ) / fNghd

   !cput = MPI_WTIME()
   !write(ounit,'("qmfs="99f10.6)') qfms(ll,nc)%trvs(1,0:fNghd-1,0)
   !write(ounit,'("qmfs="99f10.6)') qfms(ll,nc)%trvs(2,0:fNghd-1,0)
   !write(ounit,'("pq02aa : "f10.2" : "i2" : qmfs("i3" )%v="99es10.2)') cput-cpus,isfla,ll,qfms(ll,nc)%trvs(3,0:fNghd-1,0)
   !write(ounit,'("pq02aa : "f10.2" : "i2" : qmfs("i3" )%s="es10.2,98f10.6)') cput-cpus,isfla,ll,sflerr,qfms(ll,nc)%trvs(4,1:fNghd-1,0) * qfms(ll,nc)%pq(2) / pi2

!latex \item The repetitive construction of qfmin surfaces to obtain periodic pseudo curves equally spaced in the straight-field-line angle is terminated 
!latex when a measure of the straight field line angle error is less than $10^{-3}$.

    if( sflerr.lt.1.0e-03 ) exit ! exit isfla iterations;

   enddo ! end of do isfla=0,1 loop;
   
  enddo ! end of do nc=1,npq(ll) loop over convergent rationals;
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

!latex \item The periodic pseudo curves are saved to files, \verb+.ext.qfms:xxxx+ where \verb+xxxx+ is an annulus label.

 !cput = MPI_WTIME() ; write(ounit,'("pq02aa : "f10.2" : myid="i3" ; writing periodic pseudo curves to file ;")')cput-cpus,myid

  cput = MPI_WTIME()

  write(suf,'(i4.4)')ll
  open(qfmsunit+myid,file="."//trim(ext)//".qfms:"//suf,status="unknown",form="unformatted") ! this will contain Poincare plot data; 
  write(qfmsunit+myid)Nghd,npq(ll)

  ALLOCATE(nu,(0:fNghd-1)) 

  do nc=1,npq(ll) ; pp=pqorbit(ll,nc)%pq(1) ; qq=pqorbit(ll,nc)%pq(2)

   nu(0:fNghd-1) = qfms(ll,nc)%trvs(3,0:fNghd-1,0)
   ifail=0 ; call slowft( nu(0:fNghd-1) , fNghd , ifail )
   write(ounit,'("pq02aa : "f10.2" : myid="i3" ; ll="i3" ; pscale="es13.5" ; "i3" /"i4" : nu_m=",99es12.4)')cput-cpus,myid,ll,pscale,pp,qq,nu(fNghd-1:fNghd-Nghd:-1)

   write(qfmsunit+myid)pp,qq,shear
   write(qfmsunit+myid)qfms(ll,nc)%trvs(1,0:fNghd,0:qq-1)
   write(qfmsunit+myid)qfms(ll,nc)%trvs(2,0:fNghd,0:qq-1)
   write(qfmsunit+myid)qfms(ll,nc)%trvs(3,0:fNghd,0:qq-1)
  enddo

  DEALLOCATE(nu)

 !cput = MPI_WTIME() ; write(ounit,'("pq02aa : "f10.2" : myid="i3" ; written periodic pseudo curves to file ;")')cput-cpus,myid

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
  RETURN(pq02aa)

1002 format("pq02aa : "f10.2" : myid="i3" ; ("i3" ,"i4" ) : t="f6.3" : its="i3" ; (r,v)=("f13.10,es10.2" ) ; err="es7.0" ;")
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
end subroutine pq02aa

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

subroutine pfield( phi , rtd , Brtd ) ! ode's for pseudo field line and tangent pseudo map;

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
  use constants, only : zero,one
  use inputlist, only :
  use allglobal, only : myid,cpus,actiongradient
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
  LOCALS
  
  REAL, intent(in) :: phi,rtd(7)
  REAL, intent(out) :: Brtd(7)

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
  call bf00aa( phi , rtd(1:6) , Brtd(1:6) )

  Brtd(1) = Brtd(1) + actiongradient ! convert real magnetic field to pseudo magnetic field;
  
  Brtd(7) = rtd(2) ! integrate angle to get area; used for constructing straight pseudo field line angle;

! will probably need to restructure bf00aa to allow pseudo tangent to be constructed by integration;

 ! Btrd(3:6)=(/ Btrd(3) * trd(3) + Btrd(4) * trd(5) , Btrd(3) * trd(4) + Btrd(4) * trd(6) , Btrd(5) * trd(3) + Btrd(6) * trd(5) + one , Btrd(5) * trd(4) + Btrd(6) * trd(6)/)
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
  return
  
end subroutine pfield

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
