!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

!latex \item Unpacks solution vector from Beltrami linear system solver into vector potential.
!latex (Primarily called by \verb+mp00aa+.)

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

subroutine up00aa( lNBdof , xi )

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

  use constants, only : zero, one
  use numerical, only :
  use fileunits, only : ounit
  use inputlist, only : Wup00aa, Ni, Nofe, tflux
  use cputiming, only : Tup00aa
  use allglobal, only : myid, cpus, mn, im, in, ll, iss, At, Az, dtflux, dpflux

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

  LOCALS

  INTEGER, intent(in) :: lNBdof
  REAL   , intent(in) :: xi(1:lNBdof)

  INTEGER             :: ii, ij, ip, iq, mm, nn
  REAL                :: rho, mrho, nrho

  BEGIN(up00aa)
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
  rho = iss(1)

  do ii = 0 , Ni(ll) ! unpacking solution vector;
   do ij = 1 , mn ; mm = im(ij) ; nn = in(ij)
    do ip = 0 , Nofe
     
     mrho = one ; nrho = one
     
     At(ll,ij,ip)%s(ii) = zero ; Az(ll,ij,ip)%s(ii) = zero ! default;
     
     if( At(ll,ij,ip)%i(ii).ne.0 ) then
      
      if( ll.eq.1 .and. ii.eq.Ni(ll) .and. ij.gt.1 .and. ip.eq.0 ) mrho =  mm / rho**2 ! not an independent degree of freedom;
      if( ll.gt.1 .and. ii.eq.Ni(ll) .and. ij.gt.1 .and. ip.eq.0 ) mrho =  mm          ! not an independent degree of freedom;
      
      FATALMESS(up00aa,At(ll,ij,ip)%i(ii).lt.1 .or. At(ll,ij,ip)%i(ii).gt.lNBdof,need to check dimension of xi)
      
      At(ll,ij,ip)%s(ii) = mrho * xi( At(ll,ij,ip)%i(ii) ) ! unpacking degrees of freedom;
      
     endif
          
     if( Az(ll,ij,ip)%i(ii).ne.0 ) then
      
      if( ll.eq.1 .and. ii.eq.Ni(ll) .and. ij.gt.1 .and. ip.eq.0 ) nrho = -nn          ! not an independent degree of freedom;
      if( ll.gt.1 .and. ii.eq.Ni(ll) .and. ij.gt.1 .and. ip.eq.0 ) nrho = -nn          ! not an independent degree of freedom;
      
      FATALMESS(up00aa,Az(ll,ij,ip)%i(ii).lt.1 .or. Az(ll,ij,ip)%i(ii).gt.lNBdof,need to check dimension of xi)

      Az(ll,ij,ip)%s(ii) = nrho * xi( Az(ll,ij,ip)%i(ii) ) ! unpacking degrees of freedom;
      
     endif
     
    enddo ! end of do ip;
   enddo ! end of do ij;
  enddo ! end of do ii;
  
  ij = 1 ; mm = 0 ; ii = Ni(ll) ; ip = 0
  
  mrho = one ; nrho = one
  
  if( ll.eq.1 ) then ; mrho = one / iss(1)**(mm+2) ! ; nrho = one / iss(1)**(mm  )
  endif
  
  At(ll,ij,ip)%s(ii) = mrho * dtflux(ll)
  Az(ll,ij,ip)%s(ii) = nrho * dpflux(ll)
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
  RETURN(up00aa)

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

end subroutine up00aa

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
