!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

!latex \item Outstanding tasks and future code development.

!latex \heading{Sep 2 2011 : constraining the helicity}
!latex \item In the energy functional described elsewhere, the constraint of conserved helicity is implicit.
!latex To constrain the helicity directly, consider the following.
!latex \item In each volume, \mbox{${\cal V}_l$}, bounded by the \mbox{${\cal I}_{l-1}$} and \mbox{${\cal I}_l$} interfaces, 
!latex the plasma energy, \mbox{$U_l$}, and the global-helicity, \mbox{$M_l$}, are given by the integrals:
!latex \be U_l & = & \int_{{\cal V}_l} \left( \frac{p}{\gamma-1} + \frac{B^2}{2\mu_0} \right) dv, \label{eq:plasmaenergy}\\ 
!latex     H_l & = & \int_{{\cal V}_l} {\bf A} \cdot {\bf B} \; dv, \label{eq:helicity}
!latex \ee
!latex where \mbox{${\bf B}=\nabla \times {\bf A}$}.
!latex \item The equilibrium states that we seek minimize the total plasma energy, subject to the constraints of conserved, {\em and given} helicity.
!latex The free-energy functional we seek to extremize is
!latex \be F_l = U_l - \mu_l ( H_l-H_{l,o} ) / 2 , \label{eq:constrainedenergyfunctional}
!latex \ee
!latex where \mbox{$\mu_l$} is a Lagrange multiplier and $H_{l,o}$ is the required helicity.
!latex \item The first variation in the plasma energy the field, \mbox{$\delta {\bf A}$}, for a variation in the field is given
!latex \be \delta F_l = \int_{{\cal V}_l} \left( \frac{\nabla \times {\bf B}}{\mu_0}-\mu_l {\bf B} \right) \cdot \delta {\bf A} \; dv \label{eq:firstvariation},
!latex \ee
!latex which shows that extremizing fields are Beltrami fields.
!latex Note that this, for a given $\mu_l$, is a linear equation for the field.
!latex \item The first variation of $F_l$ for a variation in $\mu_l$ is
!latex \be \delta F_l = - \delta \mu_l ( H_l-H_{l,o} ) / 2.
!latex \ee
!latex The Lagrange multiplier, $\mu_l$, must be adjusted so that this is satisfied.

!latex \heading{Sep 2 2011 : exploiting symmetries}

!latex \item Various symmetry properties have not yet been fully exploited.
!latex By doing so, a significant increase in speed may be achieved.
!latex \item For example, the finite element basis functions (see \verb+fe00aa+) satisfy $\varphi_{1,p}(x)=(-1)^p \varphi_{0,p}(1-x)$.
!latex \item Other terms include the \verb+agss+, \verb+agst+, \verb+agsz+, \verb+agtt+, \verb+agtz+, \verb+agzz+ and \verb+agoo+, which are calculated in \verb+me00ab+.
!latex Also, note that \verb+agoo+ is integrable analytically, so Gaussian integration is {\em not} required to compute this term (see \verb+ma00aa+).

!latex \heading{Sep 2 2011 : locating magnetic axis}

!latex \item It would be convenient to locate the magnetic axis.
!latex Perhaps we could find the $R_n$ and $Z_n$, where $R_a = \sum_n R_n \cos(-n\z)$ and $Z_a = \sum_n Z_n \sin(-n\z)$, that minimize
!latex \be S = \int \left[ A_R(R_a,Z_a,\z) R_a' + A_Z(R_a,Z_a,\z) Z_a' - A_\phi(R_a,Z_a,\z) \right] d\z,
!latex \ee
!latex where ${\bf A} = A_R \nabla R + A_Z \nabla Z + A_\phi \nabla \phi = A_\s \nabla \s + A_\t \nabla \t + A_\z \nabla \z$.
!latex \item In addition, the rotational transform on the axis (required by \verb+tr00ab+) and the stability of the axis should be determined.

!latex \heading{Sep 2 2011 : Gaussian integration, revisited}

!latex \item The correct choice for the type and resolution of the Gaussian integration, see \verb+ma00aa+, should be determined.
!latex Given that the coordinates are interpolated using piecewise cubic polynomials, see \verb+ih00aa+,
!latex the degree of the radial polynomials that describe the $g_{\s\s}$, $g_{\s\t}$, etc. is easy to determine.
!latex \item A problem that occurs is that the Jacobian appears in the denominator.
!latex Perhaps we can assume the Jacobian is approximately constant, so that the degree of the polynomial to be integrated can be determined,
!latex and consequently the `best' type and resolution of the Gaussian integration can be determined apriori.
!latex \item In the innermost volume, the terms to be integrated involve factors such as $s^{m+2}$, see \verb+ma01af+.
!latex Whether Gaussian quadrature is suitable for these integrations needs to be investigated.

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

subroutine future


end subroutine future

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
